(function($, Drupal) {

  Drupal.behaviors.openlayers_plus = {
      attach : function(context, setting) {

        $('a.toggle_button').click(function(){
          $(this).toggleClass("down");

          $('div#'+$(this).attr('id')).toggle();

          if($(this).attr('class').indexOf('down') != -1){
            $.cookie($(this).html(), 'down');

          }else{
            $.cookie($(this).html(), 'up');

          }

        });

        $('.maptext a.popup-close').click(function(){
          var klass = $(this).parent().attr('id');
          $('div.'+klass).children(':first').toggleClass("down");

          $(this).parent().hide();
          $.cookie($(this).siblings('h2').children(':first').html(), 'down');

        });

        var data = $(context).data('openlayers');
        if (data && data.map.behaviors.openlayers_plus_behavior_maptext) {
          var ctrl;
          var map = data.openlayers;

          var controls = {
              // top left control
              first:{
                id: 1, 
                content: setting.openlayers_plus.first.description, 
                title: setting.openlayers_plus.first.title,
                btnLabel: setting.openlayers_plus.first.title,

                top: 0,
                bottom: 100,
                left:0
              },

              // middle left control
              second:{
                id: 2, 
                content: setting.openlayers_plus.second.description, 
                title: setting.openlayers_plus.second.title,
                btnLabel: setting.openlayers_plus.second.title,

                top : 0,
                right : 0,
                bottom : 100
              },

              // bottom left control
              third:{
                id: 3, 
                content: setting.openlayers_plus.third.description, 
                title: setting.openlayers_plus.third.title,
                btnLabel: setting.openlayers_plus.third.title,

                left:0,
                top : 100,
                bottom : 0
              }

          }
          var map_control;
          var control_collection = new toggles();

          for each(var objt in controls){
            map_control = new toggle(objt.id, objt.title, objt.btnLabel, objt.content, objt.left, objt.right, objt.top, objt.bottom);
            control_collection.addElement(map_control);
          }

          control_collection.showControlHTML(map);
          control_collection.showButtonHTML(map);

        }
      }
  };

  Object.size = function(obj) {
    var size = 0, key;
    for (key in obj) {
      if (obj.hasOwnProperty(key)) size++;
    }
    return size;
  };


  function toggle(id,cTitle, blabel, ctrl, lft, rgt, tp, btm){
    this.iD = id;
    this.buttonlabel = blabel;

    this.controlTitle = cTitle;
    this.controlcontent = ctrl;

    this.left = lft;
    this.top = tp;
    this.right = rgt; 
    this.bottom = btm;

    this.draw = function(content){
      var element = new mtext();

      element.html = content;

      element.top = this.top;
      element.bottom = this.bottom;
      element.right = this.right;
      element.left = this.left;

      return element;
    }
  }

  function toggles(){
    this.elements = [];

    this.addElement = function(instance){
      this.elements.push(instance);

    }

    this.showControlHTML = function(map){
      var mapHTML;
      for each(var toggleObject in this.elements){

        mapHTML = toggleObject.draw('<div class="maptext" id="'+toggleObject.iD+'">'+
            '<a class="popup-close" href="#close">X</a>	<h2 class="popup-title"><a href="">'+toggleObject.controlTitle+'</a></h2>'+
            '<div class="popup-content">'+toggleObject.controlcontent+'</div>'+
            '<div class="popup-pager"><ul class="links" style="display: none;">'+
            '<li><a class="prev disabled" href="#prev">Prev</a></li>'+
            '<li><a class="next" href="#next">Next</a></li>'+
            '</ul><span class="count">1 / 0</span></div>'
            +'</div>');

        if(toggleObject.controlTitle != ""){
          map.addControl(mapHTML);
          if($.cookie(toggleObject.controlTitle) == 'down'){
            $('div#'+toggleObject.iD).hide();
          }

        }

      }

    }

    this.showButtonHTML = function(map){

      var bnGroup = "";
      var hideAnchor = [];
      for each(var toggleobject in this.elements){
        if(toggleobject.buttonlabel != ""){
          bnGroup = bnGroup + '<div class="'+toggleobject.iD+'"><a class="toggle_button" id="'+toggleobject.iD+'" title="button">'+toggleobject.buttonlabel+'</a></div>';
          if($.cookie(toggleobject.buttonlabel) == 'down'){

            hideAnchor.push(toggleobject.iD);
          }
        }
      }

      toggleobject.top = 100;
      toggleobject.right = 0;
      toggleobject.left = "";
      toggleobject.bottom = 0;

      group = "<div class='bnContainer'>"+bnGroup+"</div>";

      if(bnGroup != ""){
        map.addControl(toggleobject.draw(group));
      }
      for each(var x in hideAnchor){
        $('div.bnContainer').find('a#'+x).toggleClass('down');

      }


    }

  }


})(jQuery, Drupal);

mtext = OpenLayers.Class(OpenLayers.Control.Attribution, {

  separator: ", ",
  html: "",

  top:"",
  right:"",
  bottom:"",
  left:"",

  destroy: function() {
    this.events.un({
      "removelayer": this.updateAttribution,
      "addlayer": this.updateAttribution,
      "changelayer": this.updateAttribution,
      "changebaselayer": this.updateAttribution,
      scope: this
    });

    OpenLayers.Control.prototype.destroy.apply(this, arguments);
  },    

  draw: function() {
    OpenLayers.Control.prototype.draw.apply(this, arguments);

    this.events.on({
      'changebaselayer': this.updateAttribution,
      'changelayer': this.updateAttribution,
      'addlayer': this.updateAttribution,
      'removelayer': this.updateAttribution,
      scope: this
    });

    this.div.style.top = this.top;
    this.div.style.right = this.right;
    this.div.style.bottom = this.bottom;
    this.div.style.left = this.left;

    this.updateAttribution();

    return this.div;    
  },

  updateAttribution: function() {
    if (this.map && this.map.layers) {
      this.div.innerHTML = this.html;

    }
  },

  CLASS_NAME: "OpenLayers.Control.Maptext"
});
